/* Generated by powerful Codeforces Tool
 * Author: xxxodarap
 * Time: 2023-08-26 17:24
**/

#include<bits/stdc++.h>
using namespace std;
namespace R = std::ranges;

#define F(i, a, e) for(ll i = (a); i < (e); i++)
#define R(i, e) F(i, 0, e)

typedef long long ll;
typedef double lf;
typedef complex<lf> cp;
typedef pair<int, int> pii;


template<class T> bool ckmin(T& a, const T& b) { return b < a ? a = b, 1 : 0; }
template<class T> bool ckmax(T& a, const T& b) { return a < b ? a = b, 1 : 0; }


const lf PI = acos(-1), EPSI = 1e-9;

mt19937 rng(chrono::steady_clock::now().time_since_epoch().count());


// =============== Solution section ===============
const int MAXN = 3000 + 9;
/* const int MAXN = 30 + 9; */
ll N;
string s;

vector<bitset<MAXN>> store;
vector<bitset<MAXN>> g;

void show(){
    cerr << "This is s: " << s << endl;
    cerr << "This is g:" << endl;
    for(auto b: g)
        cerr << b << endl;
}

void solve(){
    // Code goes here ...
    cin >> N;

    ll cnt = 0;
    g = vector<bitset<MAXN>>(N);

    R(i, N){
        cin >> s;
        reverse(begin(s), end(s));
        /* show(); */

        R(j, N){
            if((s[j] == '1') ^ g[i][j]){
                cnt++;
                F(k, i, N){
                    if(j - (k-i) >= 0)
                        g[k] ^= store[k - i] << (j - (k - i));
                    else
                        g[k] ^= store[k - i] >> -(j - (k - i));
                }
            }
        }
    }

    cout << cnt << endl;
}


// =============== Main section ===============
int main(){
    ios_base::sync_with_stdio(0); cin.tie(0);
    cout << setprecision(12); // << fixed;

    bitset<MAXN> cur;
    cur.set(0);
    for(int i = 1; i < MAXN - 2; i += 2){
        store.push_back(cur);
        cur.set(i);
        cur.set(i + 1);
    }

    int T = 1;
    cin >> T;
    while(T--)
        solve();

    return 0;
}
        
